package org.supermind.crawl;

import org.apache.nutch.protocol.ProtocolOutput;
import org.apache.nutch.util.LogFormatter;

import java.net.URL;
import java.io.IOException;
import java.util.logging.Logger;

/**
 * Database of URLs that have already been fetched.
 */
public interface FetchedURLs {
    static Logger LOG =
      LogFormatter.getLogger(FetchedURLs.class.getName());
  /**
   * Has the URL already been fetched? 
   * @param url
   * @return
   */
  boolean contains(URL url);

  /**
   * Insert a fetched URL.
   * @param url url
   * @param output protocol output
   */
  void insert(ScheduledURL url, ProtocolOutput output) throws IOException;

  /**
   * Get a persisted URL. (optional operation)
   * @param id ScheduledURL's id
   * @return ScheduledURL, or null if doesn't exist
   * @throws UnsupportedOperationException if the implementation doesn't save ScheduledURLs 
   */
  ScheduledURL get(long id);

  void close() throws IOException;

  void init() throws IOException;
}
