package org.supermind.crawl;

import org.apache.nutch.protocol.ProtocolOutput;

import java.util.HashSet;
import java.util.Set;
import java.net.URL;
import java.io.IOException;

/**
 * Saves fetched URLs to a HashSet. Not recommended for large crawls.
 */
public class InMemoryFetchedURLs implements FetchedURLs {
  private Set<String> fetched = new HashSet();

  public synchronized boolean contains(String url) {
    return fetched.contains(url);
  }

  public void insert(ScheduledURL url, ProtocolOutput output) {
    fetched.add(url.url.toString());
  }

  public ScheduledURL get(long id) {
    throw new UnsupportedOperationException("get() not supported");
  }
  
  public boolean contains(URL url) {
    return fetched.contains(url.toString());
  }

  public void init() throws IOException {

  }

  public void close() throws IOException {
    fetched.clear();
  }

  public synchronized void insert(String url) {
    fetched.add(url);
  }
}
