package org.supermind.crawl;

import org.apache.nutch.fs.NutchFileSystem;
import org.apache.nutch.io.ArrayFile;
import org.apache.nutch.pagedb.FetchListEntry;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Iterator;

/**
 * Uses a Nutch FetchList to seed a crawl.
 */
public class NutchFetchListCrawlSeedSource implements CrawlSeedSource {
  private String file;
  private NutchFileSystem nfs;
  ArrayFile.Reader fetchList;
  FetchListEntry nextEntry;
  boolean next;
  int idx = 0;
  Iterator it;

  public NutchFetchListCrawlSeedSource() {
    init();
  }

  private void init() {
    try {
      fetchList = new ArrayFile.Reader(nfs, file);
      nextEntry = new FetchListEntry();
      next = fetchList.next(nextEntry) != null;
    } catch (IOException e) {
      throw new IllegalStateException(e);
    }
  }

  private void initIterator() {
    it = new Iterator() {

      public boolean hasNext() {
        if (fetchList == null) init();
        return next;
      }

      public SeedURL next() {
        if (fetchList == null) init();
        SeedURL seed = null;
        try {
          seed = new SeedURL(new URL(nextEntry.getUrl().toString()), idx++);
        } catch (MalformedURLException e) {
        }
        try {
          next = fetchList.next(nextEntry) != null;
        } catch (IOException e) {
          e.printStackTrace();
          nextEntry = null;
        }
        return seed;
      }

      public void remove() {
        throw new UnsupportedOperationException();
      }
    };
  }


  public void close() throws IOException {
    it = null;
    if(fetchList != null) fetchList.close();
  }

  public Iterator<SeedURL> getSeedURLs() throws IOException {
    if(it == null) initIterator();
    return it;
  }


  public SeedURL getSeedURL(int index) {
    throw new UnsupportedOperationException();
  }

  public void setFile(String file) {
    this.file = file;
  }

  public void setNfs(NutchFileSystem nfs) {
    this.nfs = nfs;
  }
}
