package org.supermind.crawl;

import org.apache.nutch.parse.Parse;
import org.apache.nutch.protocol.Content;

import java.io.IOException;
import java.util.List;

/**
 * Chain of {@link PostFetchProcessor}s.
 */
public class PostFetchProcessorChain implements PostFetchProcessor{
  private List<PostFetchProcessor> processors;
  public void process(FetcherOutput fo, Content content, Parse parse) throws IOException {
    for(PostFetchProcessor pp : processors) {
      pp.process(fo, content, parse);
    }
  }

  public void close() throws IOException {
    for(PostFetchProcessor pp : processors) {
      pp.close();
    }
  }

  public void setProcessors(List<PostFetchProcessor> processors) {
    this.processors = processors;
  }
}
