package org.supermind.crawl.scope;

/**
 * Allows a URL if it has the same path or host as its parent (originating page), .
 */
public class ParentPrefixPathFLFilter extends SameParentHostFLFilter {
  public int filter(FetchListScope.Input input) {
    String parent = input.parent.url.toString();
    String in = input.url.toString();
    int parentlastslash = parent.lastIndexOf("/");
    int inlastslash = in.lastIndexOf("/");
    if (parentlastslash != -1) {
      if(inlastslash > -1 &&
          in.substring(0, inlastslash).startsWith(parent.substring(0, parentlastslash))) return ALLOW;
    } else {
      return super.filter(input);
    }

    return REJECT;
  }
}
