package org.supermind.crawl.scope;

import java.net.URL;

/**
 * Allows a URL if it has the same host as its parent (originating page).
 */
public class SameParentHostFLFilter implements ScopeFilter<FetchListScope.Input>{
  public int filter(FetchListScope.Input input) {
    URL parent = input.parent.url;
    if(parent.getHost().equals(input.url.getHost())) return ALLOW;

    return REJECT;
  }
}
