package org.supermind.crawl.scope;

/**
 * Determines the scope of an operation. Filters <b>must</b> be thread-safe. 
 */
public interface ScopeFilter<T> {
  static final int ALLOW = 0;
  static final int REJECT = 1;
  static final int ABSTAIN = 2;

  /**
   * Filter the input. Possible return values are {@link #ALLOW}, {@link #REJECT}
   * and {@link #ABSTAIN}.
   * @param t
   * @return
   */
  int filter(T t);
}
