package org.supermind.crawl.util;

import org.apache.nutch.fs.LocalFileSystem;
import org.apache.nutch.fs.NutchFileSystem;
import org.apache.nutch.io.*;
import org.apache.nutch.util.LogFormatter;
import org.supermind.crawl.util.MapFilePersister;

import java.io.File;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Comparator;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Saves MD5Hash values to a {@link org.apache.nutch.io.MapFile}.
 */
public class MD5Persister extends MapFilePersister<MD5Hash, NullWritable> {
  private MD5Hash throwAwayValue = new MD5Hash();

  public void add(MD5Hash hash) throws IOException {
    super.add(hash, null);
  }

  public boolean contains(MD5Hash hash) throws IOException {
    boolean b = buffer.containsKey(hash);
    if (!b) {
      try {
        if (reader == null) reader = new MapFile.Reader(nfs, mapdir);
      } catch (FileNotFoundException e) {
        return false;
      }
      return reader.seek(hash);
    } else {
      return true;
    }
  }

  protected WritableComparator getKeyComparator() {
    return new MD5Hash.Comparator();
  }

  public Comparator getTypeComparator() {
    return new MD5Hash.Comparator();
  }

  public WritableComparable getKeyInstance(MD5Hash md5Hash, boolean throwaway) {
    if(md5Hash != null) return md5Hash;
    else
      return new MD5Hash();
  }
}
